# Source for file Memcache.php

Documentation is available at Memcache.php

1. <?php
2. /*
3. * $Id: Memcache.php 1080 2007-02-10 18:17:08Z romanb $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
21. Doctrine::autoload('Doctrine_Cache_Driver');
22. /**
23. * Doctrine_Cache_Memcache
24. *
25. * @package Doctrine
26. * @subpackage Doctrine_Cache
27. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28. * @category Object Relational Mapping
29. * @link www.phpdoctrine.com
30. * @since 1.0
31. * @version $Revision: 1080 $
32. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
33. */
34. class Doctrine_Cache_Memcache extends Doctrine_Cache_Driver
35. {
36. /**
37. * @var Memcache $_memcache memcache object
38. */
39. protected $_memcache = null;
40. /**
41. * constructor
42. *
43. * @param array $options associative array of cache driver options
44. */
45. public function __construct($options = array())
46. {
47. if ( ! extension_loaded('memcache')) {
48. throw new Doctrine_Cache_Exception('In order to use Memcache driver, the memcache extension must be loaded.');
49. }
50. parent::__construct($options);
52. if (isset($options['servers'])) {
53. $value= $options['servers'];
54. if (isset($value['host'])) {
55. // in this case, $value seems to be a simple associative array (one server only)
56. $value = array(0 => $value); // let's transform it into a classical array of associative arrays
57. }
58. $this->setOption('servers', $value);
59. }
61. $this->_memcache = new Memcache;
63. foreach ($this->_options['servers'] as $server) {
64. if ( ! array_key_exists('persistent', $server)) {
65. $server['persistent'] = true;
66. }
67. if ( ! array_key_exists('port', $server)) {
68. $server['port'] = 11211;
69. }
70. $this->_memcache->addServer($server['host'], $server['port'], $server['persistent']);
71. }
72. }
73. /**
74. * Test if a cache is available for the given id and (if yes) return it (false else)
75. *
76. * Note : return value is always "string" (unserialization is done by the core not by the backend)
77. *
78. * @param string $id cache id
79. * @param boolean $testCacheValidity if set to false, the cache validity won't be tested
80. * @return string cached datas (or false)
81. */
82. public function fetch($id, $testCacheValidity = true)
83. {
84. $tmp = $this->_memcache->get($id);
86. if (is_array($tmp)) {
87. return $tmp[0];
88. }
90. return false;
91. }
92. /**
93. * Test if a cache is available or not (for the given id)
94. *
95. * @param string $id cache id
96. * @return mixed false (a cache is not available) or "last modified" timestamp (int) of the available cache record
97. */
98. public function contains($id)
99. {
100. return (bool) $this->_memcache->get($id);
101. }
102. /**
103. * Save some string datas into a cache record
104. *
105. * Note : $data is always saved as a string
106. *
107. * @param string $data data to cache
108. * @param string $id cache id
109. * @param int $lifeTime if != false, set a specific lifetime for this cache record (null => infinite lifeTime)
110. * @return boolean true if no problem
111. */
112. public function save($id, $data, $lifeTime = false)
113. {
114. if ($this->_options['compression']) {
115. $flag = MEMCACHE_COMPRESSED;
116. } else {
117. $flag = 0;
118. }
120. $result = $this->_memcache->set($id, $data, $flag, $lifeTime);
121. }
122. /**
123. * Remove a cache record
124. *
125. * @param string $id cache id
126. * @return boolean true if no problem
127. */
128. public function delete($id)
129. {
130. return $this->_memcache->delete($id);
131. }
132. }